# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .agent import Agent

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ListAgentsResponse(pydantic.BaseModel):
    """
    import datetime

    from flatfile import Agent, Compiler, EventTopic, ListAgentsResponse

    ListAgentsResponse(
        data=[
            Agent(
                id="us_ag_YOUR_ID",
                topics=[EventTopic.WORKBOOK_UPDATED],
                compiler=Compiler.JS,
                source="module.exports = { routeEvent: async (...args) => { console.log(args) } }",
                slug="default",
                created_at=datetime.datetime.fromisoformat(
                    "2023-10-30 16:59:45.735000+00:00",
                ),
                updated_at=datetime.datetime.fromisoformat(
                    "2023-10-30 16:59:45.735000+00:00",
                ),
                account_id="us_acc_YOUR_ID",
                environment_id="us_env_YOUR_ID",
            )
        ],
    )
    """

    data: typing.Optional[typing.List[Agent]] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
