# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class ActionMode(str, enum.Enum):
    """
    Foreground actions will prevent interacting with the resource until complete
    """

    FOREGROUND = "foreground"
    BACKGROUND = "background"
    TOOLBAR_BLOCKING = "toolbarBlocking"

    def visit(
        self,
        foreground: typing.Callable[[], T_Result],
        background: typing.Callable[[], T_Result],
        toolbar_blocking: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is ActionMode.FOREGROUND:
            return foreground()
        if self is ActionMode.BACKGROUND:
            return background()
        if self is ActionMode.TOOLBAR_BLOCKING:
            return toolbar_blocking()
