# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class GuestAuthenticationEnum(str, enum.Enum):
    """
    The type of authentication to use for guests
    ---
    from flatfile import GuestAuthenticationEnum

    GuestAuthenticationEnum.MAGIC_LINK
    """

    SHARED_LINK = "shared_link"
    MAGIC_LINK = "magic_link"

    def visit(self, shared_link: typing.Callable[[], T_Result], magic_link: typing.Callable[[], T_Result]) -> T_Result:
        if self is GuestAuthenticationEnum.SHARED_LINK:
            return shared_link()
        if self is GuestAuthenticationEnum.MAGIC_LINK:
            return magic_link()
