# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ...commons.types.pagination import Pagination
from .environment import Environment

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ListEnvironmentsResponse(pydantic.BaseModel):
    """
    from flatfile import (
        Environment,
        GuestAuthenticationEnum,
        ListEnvironmentsResponse,
    )

    ListEnvironmentsResponse(
        data=[
            Environment(
                id="us_env_YOUR_ID",
                account_id="us_acc_YOUR_ID",
                name="dev",
                is_prod=False,
                guest_authentication=[GuestAuthenticationEnum.MAGIC_LINK],
                features={},
                metadata={},
                namespaces=["default"],
            )
        ],
    )
    """

    data: typing.List[Environment]
    pagination: typing.Optional[Pagination] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
