# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .context import Context
from .domain import Domain
from .event_attributes import EventAttributes
from .origin import Origin

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class BaseEvent(pydantic.BaseModel):
    domain: Domain = pydantic.Field(description="The domain of the event")
    context: Context = pydantic.Field(description="The context of the event")
    attributes: typing.Optional[EventAttributes] = pydantic.Field(
        default=None, description="The attributes of the event"
    )
    callback_url: typing.Optional[str] = pydantic.Field(
        alias="callbackUrl", default=None, description="The callback url to acknowledge the event"
    )
    data_url: typing.Optional[str] = pydantic.Field(
        alias="dataUrl", default=None, description="The url to retrieve the data associated with the event"
    )
    target: typing.Optional[str] = None
    origin: typing.Optional[Origin] = None
    namespaces: typing.Optional[typing.List[str]] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
