# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ...commons.types.environment_id import EnvironmentId
from .guest_space import GuestSpace

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class GuestConfigUpdate(pydantic.BaseModel):
    """
    Properties used to update an existing guest
    ---
    from flatfile import GuestConfigUpdate

    GuestConfigUpdate(
        email="updated@example.com",
        name="Your Name Updated",
    )
    """

    environment_id: typing.Optional[EnvironmentId] = pydantic.Field(alias="environmentId", default=None)
    email: typing.Optional[str] = None
    name: typing.Optional[str] = None
    spaces: typing.Optional[typing.List[GuestSpace]] = None

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
