# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ...commons.types.guest_id import GuestId
from ...commons.types.space_id import SpaceId

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class Invite(pydantic.BaseModel):
    """
    from flatfile import Invite

    Invite(
        guest_id="us_g_YOUR_ID",
        space_id="us_sp_YOUR_ID",
        from_name="Your Name",
        message="Hello, I would like to invite you to my space.",
    )
    """

    guest_id: GuestId = pydantic.Field(alias="guestId")
    space_id: SpaceId = pydantic.Field(alias="spaceId")
    from_name: typing.Optional[str] = pydantic.Field(
        alias="fromName", default=None, description="The name of the person or company sending the invitation"
    )
    message: typing.Optional[str] = pydantic.Field(default=None, description="Message to send with the invite")

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
