# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .category_mapping import CategoryMapping
from .enum_value import EnumValue

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class EnumDetails(pydantic.BaseModel):
    """
    Only available if one or more of the destination fields is of type enum. Provides category mapping.
    """

    mapping: typing.List[CategoryMapping] = pydantic.Field(
        description="The mapping of source values to destination values"
    )
    unused_source_values: typing.Optional[typing.List[EnumValue]] = pydantic.Field(
        alias="unusedSourceValues", default=None, description="A list of source values that are not mapped from"
    )
    unused_destination_values: typing.Optional[typing.List[EnumValue]] = pydantic.Field(
        alias="unusedDestinationValues", default=None, description="A list of destination values that are not mapped to"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
