# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .driver import Driver

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class FileJobConfig(pydantic.BaseModel):
    driver: Driver = pydantic.Field(description="The driver to use for extracting data from the file")
    options: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        default=None, description="The options to use for extracting data from the file"
    )
    detected_header_row: typing.Optional[int] = pydantic.Field(
        alias="detectedHeaderRow",
        default=None,
        description="The row number of the header row detected at extraction time",
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
