# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from .job_outcome_next import JobOutcomeNext
from .job_outcome_trigger import JobOutcomeTrigger

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class JobOutcome(pydantic.BaseModel):
    """
    Outcome summary of a job
    ---
    from flatfile import JobOutcome, JobOutcomeNext_Id

    JobOutcome(
        acknowledge=True,
        button_text="Acknowledge",
        next=JobOutcomeNext_Id(
            type="id",
            id="us_jb_YOUR_ID",
        ),
        heading="Success",
        message="Job was successful",
    )
    """

    acknowledge: typing.Optional[bool] = None
    trigger: typing.Optional[JobOutcomeTrigger] = None
    button_text: typing.Optional[str] = pydantic.Field(alias="buttonText", default=None)
    next: typing.Optional[JobOutcomeNext] = None
    heading: typing.Optional[str] = None
    message: typing.Optional[str] = None
    hide_default_button: typing.Optional[bool] = pydantic.Field(alias="hideDefaultButton", default=None)

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
