# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ...commons.types.sheet_id import SheetId
from ...commons.types.workbook_id import WorkbookId
from .sheet_config import SheetConfig

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class SheetUpdate(pydantic.BaseModel):
    """
    Changes to make to an existing sheet
    """

    id: typing.Optional[SheetId] = pydantic.Field(default=None, description="The ID of the Sheet.")
    workbook_id: typing.Optional[WorkbookId] = pydantic.Field(
        alias="workbookId", default=None, description="The ID of the Workbook."
    )
    config: typing.Optional[SheetConfig] = pydantic.Field(
        default=None, description="Describes shape of data as well as behavior."
    )
    metadata: typing.Optional[typing.Any] = pydantic.Field(
        default=None, description="Useful for any contextual metadata regarding the sheet. Store any valid json"
    )
    namespace: typing.Optional[str] = pydantic.Field(default=None, description="The scoped namespace of the Sheet.")
    updated_at: typing.Optional[dt.datetime] = pydantic.Field(
        alias="updatedAt", default=None, description="Date the sheet was last updated"
    )
    created_at: typing.Optional[dt.datetime] = pydantic.Field(
        alias="createdAt", default=None, description="Date the sheet was created"
    )

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        allow_population_by_field_name = True
        json_encoders = {dt.datetime: serialize_datetime}
