# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ....core.datetime_utils import serialize_datetime
from ...commons.types.pagination import Pagination
from .view import View

try:
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ListViewsResponse(pydantic.BaseModel):
    """
    from flatfile import (
        Filter,
        ListViewsResponse,
        Pagination,
        SortDirection,
        View,
        ViewConfig,
    )

    ListViewsResponse(
        data=[
            View(
                id="us_vi_YOUR_ID",
                sheet_id="us_sh_YOUR_ID",
                name="My View",
                config=ViewConfig(
                    filter=Filter.ERROR,
                    filter_field="email",
                    q="firstname like %John%",
                    sort_field="email",
                    sort_direction=SortDirection.ASC,
                ),
                created_by="us_usr_YOUR_ID",
            )
        ],
        pagination=Pagination(
            current_page=3,
            page_count=50,
            total_count=100,
        ),
    )
    """

    pagination: typing.Optional[Pagination] = None
    data: typing.List[View]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
